/*********************************************************************

        Nintendo GameCube ADPCM Decoder Core Class
        Author: Shinji Chiba <ch3@mail.goo.ne.jp>

        History: Mar.19 2001 - Create.

*********************************************************************/
#ifndef __NGCADPCM_H__
#define __NGCADPCM_H__

#ifdef _WINDOWS
#include <windows.h>
#elif _XBOX
#include <xtl.h>
#endif

#define ONE_BLOCK_SIZE		32
#define SAMPLES_PER_BLOCK	28
#define MONO				1
#define STEREO				2

class NGCADPCM
{
protected:
	float iir1[STEREO], iir2[STEREO];

private:
	short DecodeSample( int, int, int );

protected:
	void InitFilter();
	void DecodeBlock( short*, LPBYTE, int );

public:
	NGCADPCM();
};

#endif
